% Compile MEX files to speed up computations.
%
% (C) 2017 by A. Bemporad, October 2, 2017

Cfg = coder.config('mex');
Cfg.DynamicMemoryAllocation='AllVariableSizeArrays';
Cfg.IntegrityChecks = false;
Cfg.ResponsivenessChecks = false;
Cfg.SaturateOnIntegerOverflow = false;

fun='jm_fit';
outputFileName = [fun '_mex'];
X = coder.typeof(0,[inf,inf]);
Y = coder.typeof(0,[inf,inf]);
S = coder.typeof(0,[inf,1]);
rho = 0;
Linit = coder.typeof(0,[inf,1]);
Lmode = coder.typeof(0,[inf,1]);
Ltrans = coder.typeof(0,[inf,inf]);
kmax = 0;
Vtol = 0;
loss_type = 0;
tau_PWA = 0;
codegen('-config',Cfg,fun,'-o',outputFileName,'-args',{X,Y,S,rho,Linit,Lmode,Ltrans,kmax,Vtol,loss_type,tau_PWA},...
    '-d', fullfile(tempdir,'mex',fun,computer('arch')));


fun='jm_dp';
outputFileName = [fun '_mex'];
X = coder.typeof(0,[inf,inf]);
Y = coder.typeof(0,[inf,inf]);
TH = coder.typeof(0,[inf,inf,inf]);
Linit = coder.typeof(0,[inf,1]);
Lmode = coder.typeof(0,[inf,1]);
Ltrans = coder.typeof(0,[inf,inf]);
inference_flag = 0;
loss_type = 0;
tau_PWA = 0;
c = coder.typeof(0,[inf,inf]);
codegen('-config',Cfg,fun,'-o',outputFileName,'-args',{X,Y,TH,Linit,Lmode,Ltrans,inference_flag,loss_type,tau_PWA,c},...
    '-d', fullfile(tempdir,'mex',fun,computer('arch')));


fun='jm_recursive_inference';
outputFileName = [fun '_mex'];
X = coder.typeof(0,[inf,inf]);
Y = coder.typeof(0,[inf,inf]);
TH = coder.typeof(0,[inf,inf,inf]);
Linit = coder.typeof(0,[inf,1]);
Lmode = coder.typeof(0,[inf,1]);
Ltrans = coder.typeof(0,[inf,inf]);
inference_flag = 0;
loss_type = 0;
prediction_type = 0;
codegen('-config',Cfg,fun,'-o',outputFileName,'-args',{X,Y,TH,Linit,Lmode,Ltrans,loss_type,prediction_type},...
    '-d', fullfile(tempdir,'mex',fun,computer('arch')));

fun='jm_trans_prob';
outputFileName = [fun '_mex'];
S = coder.typeof(0,[inf,1]);
K = 0;
codegen('-config',Cfg,fun,'-o',outputFileName,'-args',{S,K},...
    '-d', fullfile(tempdir,'mex',fun,computer('arch')));


fun='jm_loss';
outputFileName = [fun '_mex'];
X = coder.typeof(0,[inf,inf]);
Y = coder.typeof(0,[inf,inf]);
S = coder.typeof(0,[inf,1]);
TH = coder.typeof(0,[inf,inf,inf]);
loss_type = 0;
tau_PWA = 0;
c = coder.typeof(0,[inf,inf]);
codegen('-config',Cfg,fun,'-o',outputFileName,'-args',{X,Y,S,TH,loss_type,tau_PWA,c},...
    '-d', fullfile(tempdir,'mex',fun,computer('arch')));


fun='jm_mode_loss';
outputFileName = [fun '_mex'];
P = coder.typeof(0,[inf,inf]);
p = coder.typeof(0,[inf,1]);
tau = coder.typeof(0,[inf,1]);
tau0 = 0;
codegen('-config',Cfg,fun,'-o',outputFileName,'-args',{P,p,tau,tau0},...
    '-d', fullfile(tempdir,'mex',fun,computer('arch')));

fun='PWA_prediction';
outputFileName = [fun '_mex'];
u = coder.typeof(0,[inf,1]);
TH = coder.typeof(0,[inf,inf]);
c = coder.typeof(0,[inf,inf]);
na = 0;
nb = 0;
prediction_type = 0;
loss_type = 0;
PWA_type = 0;
y = coder.typeof(0,[inf,1]);
codegen('-config',Cfg,fun,'-o',outputFileName,'-args',{u,TH,c,na,nb,prediction_type,PWA_type,y},...
    '-d', fullfile(tempdir,'mex',fun,computer('arch')));